#!/bin/sh -
#
# Copyright (c) 1988 The Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms are permitted
# provided that the above copyright notice and this paragraph are
# duplicated in all such forms and that any documentation,
# advertising materials, and other materials related to such
# distribution and use acknowledge that the software was developed
# by the University of California, Berkeley.  The name of the
# University may not be used to endorse or promote products derived
# from this software without specific prior written permission.
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
#	@(#)mkdep.sh.old.compiler	5.2 (Berkeley) 10/24/88
#

# This is a version of mkdep that works pretty well
# with compilers that don't have -M.

PATH=/bin:/usr/bin:/usr/ucb:/lib:/usr/lib

INCL=
D=.depend
append=0

while :
	do case "$1" in
		# -a appends to the depend file
		-a)
			append=1
			shift ;;

		# -f allows you to select a makefile name
		-f)
			D=$2
			shift; shift ;;

		# the -p flag produces "program: program.c" style dependencies
		# so .o's don't get produced
		-p)
			SED='s;\.o;;'
			shift ;;
		*)
			break ;;
	esac
done

if [ $# = 0 ] ; then
	echo 'usage: mkdep [-f depend_file] [cc_flags] file ...'
	exit 1
fi

TMP=/tmp/mkdep$$
trap 'rm -f $TMP ; exit 1' 1 2 3 13 15

for i do
	case "$i" in
	-c|-M)
		;;
	-I*)
		INCL="$INCL $i";;
	-D*|-O|-U*)
		FLAGS="$FLAGS $i";;
	*)
		# assume source file
		# put '$dep' in front of dependencies
		dep=`echo "$i" | sed -e 's,/,\\\\/,g' -e 's/\.c$/.o/'`

		# Find includes, remove leading numerics, remove ./,
		# remove double quotes, and remove trailing numerics.
		# Sort that, discarding duplicates, and add '$dep'.
		cpp $INCL $FLAGS "$i" | sed -e '
			/^#/!d
			s/# [0-9]* //
			s,"./,",
			s/"\(.*\)"/\1/
			s/ [ 0-9]*$//' |
		sort -u | sed -e "s/^/$dep: /";;
	esac
done |
sed "
	s; \./; ;g
	/\.c:$/d
	$SED" |
awk '{
	if ($1 != prev) {
		if (rec != "")
			print rec;
		rec = $0;
		prev = $1;
	}
	else {
		if (length(rec $2) > 78) {
			print rec;
			rec = $0;
		}
		else
			rec = rec " " $2
	}
}
END {
	print rec
}' > $TMP

if [ $append = 1 ]; then
	cat $TMP >> $D
	rm -f $TMP
else
	mv $TMP $D
fi
exit 0
